const MSNPort = '1863';

function MSNObject(callback) {
    this.bundle = getStringBundle('chrome://msnmsgr/locale/msnmsgr.properties');
    this.data = '';
    this._callback = callback ? callback : this;
    this._SOCKET = new Socket();
    this._STATUS = "HDN";
    this._TRIAL = -1;
/*    this._STATUSMSG = new Array();
    this._STATUSMSG["NLN"] = "Online";
    this._STATUSMSG["BSY"] = "Busy";
    this._STATUSMSG["AWY"] = "Away";
    this._STATUSMSG["IDL"] = "Idling";
    this._STATUSMSG["BRB"] = "Be Right Back";
    this._STATUSMSG["PHN"] = "On the Phone";
    this._STATUSMSG["LUN"] = "Out to Lunch";
    this._STATUSMSG["HDN"] = "Hidding";
    this._STATUSMSG["FLN"] = "Offline";
*/    this.Groups = new Array();
    this.Contacts = new Array();
    this.Contacts['FL'] = new Array();
    this.Contacts['RL'] = new Array();
    this.Contacts['BL'] = new Array();
    this.Contacts['AL'] = new Array();
    this.Sessions = new Array();
    this.MMS_FN = "Arial";
    this.MMS_EF_B = false;
    this.MMS_EF_I = false;
    this.MMS_EF_U = false;
    this.MMS_EF_S = false;
    this.MMS_CO = '#000000';
    this.GROUP_SORT = true;
    this.GROUP_OFFLINE = true;
}

MSNObject.prototype.logon = function(name, pass, initstat) {
    //alert(name + "\n" +
      //    pass + "\n" +
        //  initstat);
    this.passport = name;
    this.password = pass;
    this._STATUS = initstat;
    this._SOCKET.connect('messenger.hotmail.com', MSNPort, this);
    setInterval(__ping, 59999);
}

MSNObject.prototype.logout = function() {
    if (this.isConnected) {
        this._SOCKET.sendData('OUT\r\n');
        this._SOCKET.disconnect();
    }
    delete this._SOCKET;
    this._SOCKET = new Socket();
    this.Contacts = new Array();
    this.Contacts['FL'] = new Array();
    this.Contacts['RL'] = new Array();
    this.Contacts['BL'] = new Array();
    this.Contacts['AL'] = new Array();
}

MSNObject.prototype.status getter = function() {
    return this._STATUS;
}
MSNObject.prototype.status setter = function(y) {
    this._STATUS = y;
    if (!this.isConnected) return false;
    this._SOCKET.sendData('CHG ' + this.trial + ' ' + y + '\r\n', 15000);
}

MSNObject.prototype.addContact = function(email, nick, group, list) {
    if (!list) { list == 'FL' };
    var send = 'ADD ' + this.trial + ' ' + list + ' ' + email + ' ' + nick;
    if (group && list == 'FL') {
        send += ' ' + group
    }
    this._SOCKET.sendData(send + '\r\n', 60000);
}

MSNObject.prototype.removeContact = function(email, group, list) {
    if (!list) { list == 'FL' };
    var send = 'REM ' + this.trial + ' ' + list + ' ' + email;
    if (group && list == 'FL') {
        send += ' ' + group
    }
    this._SOCKET.sendData(send + '\r\n', 60000);
}

MSNObject.prototype.openURL = function(msncommand) {
    this._SOCKET.sendData('URL ' + this.trial + ' ' + msncommand + '\r\n', 60000);
}

MSNObject.prototype.changeFriendlyName = function(email, newName) {
    this._SOCKET.sendData('REA ' + this.trial + ' ' + email + ' ' + escape(newName) + '\r\n', 60000);
}

MSNObject.prototype.MMS getter = function() {
    var mms = "FN=" + escape(this.MMS_FN) + "; EF=";
    if (this.MMS_EF_B)
        mms += "B";
    if (this.MMS_EF_U)
        mms += "U";
    if (this.MMS_EF_I)
        mms += "I";
    if (this.MMS_EF_S)
        mms += "S";
    mms += "; CO=" + swapRedBlue(this.MMS_CO).substr(1, this.MMS_CO.length) + "; CS=0; PF=00";
    return mms;
}

MSNObject.prototype.CSS getter = function() {
    return convertXMMStoStyle(this.MMS);
}

MSNObject.prototype.isConnected getter = function() {
    return this._SOCKET.isConnected;
}

MSNObject.prototype.grabSessionFor = function(session) {
    this.__session = session;
    this._SOCKET.sendData('XFR ' + this.trial + ' SB\r\n', 60000);
}

MSNObject.prototype.registerSession = function(session) {
    this.Sessions[session._SESSIONID] = session;
}

MSNObject.prototype.unregisterSession = function(session) {
    delete this.Sessions[session._SESSIONID];
}

MSNObject.prototype.FontChanged = function() {
    for (var i in this.Sessions) {
        var session = this.Sessions[i];
        if (typeof(session._WINDOW) == "object") {
            session._WINDOW.FontChanged();
        }
    }
}

MSNObject.prototype.onConnect = function() {
    document.getElementById('main-pages').selectedIndex = 1;
    this._SOCKET.startAsyncRead();
    this._SOCKET.sendData('VER ' + this.trial + ' MSNP7\r\n', 60000); // MSNP6 MSNP5 MSNP4 CVR0\r\n');
}

MSNObject.prototype.onClose = function() {
    this._SOCKET = new Socket();
    document.getElementById('signin-button').disabled = false;
    document.getElementById('main-pages').selectedIndex = 0;
}

MSNObject.prototype.onStreamClose = function(status) {
    //alert(status);
}

MSNObject.prototype.onDataAvailable = function(count) {
    this.data += this._SOCKET.readData(count);
    while (this.data != '') {
        var i = this.data.indexOf('\r\n');
        if (i == -1) { return }
        var data = this.data.substr(0, i);
        this.data = this.data.substr(i+2);
        _alert("<<< " + data);
        var param = data.split(" ");
        switch (param[0]) {
            case "VER":
                this._PROTVER = param[2];
                if (this._PROTVER == 'MSNP7')
                    //this._SOCKET.sendData('INF ' + this.trial + '\r\n', 60000);
                    this._SOCKET.sendData('USR ' + this.trial + ' MD5 I ' + this.passport + '\r\n', 60000);
                else if (this._PROTVER == 'MSNP8' || this._PROTVER == 'MSNP9')
                    this._SOCKET.sendData('CVR ' + this.trial + ' 0x0409 winnt 5.1 i686 XULMSNMSGR 0.5.2 MSMSGS ' + this.passport + '\r\n');
                break;
            case "CVR":
                if (this._PROTVER == 'MSNP8' || this._PROTVER == 'MSNP9')
                    this._SOCKET.sendData('USR ' + this.trial + ' TWN I ' + this.passport + '\r\n', 60000);
                break;
/*            case "INF":
                this.__auth = param[2].substr(0,3);
                this._SOCKET.sendData('USR ' + this.trial + ' ' + this.__auth + ' I ' + this.passport + '\r\n', 60000);
                break; */
            case "XFR":
                if (param[2] == "NS") {
                    this._SOCKET.disconnect(1);
                    var host = param[3].split(":");
                    this._TRIAL = -1;
                    this._SOCKET = new Socket();
                    this._SOCKET.connect(host[0], host[1], this);
                }
                else if (param[2] == "SB") {
                    var host = param[3].split(':');
                    this.__session.open(host[0], host[1], param[5]);
                    delete this.__session;
                }
                break;
            case "USR":
                if ((param[2] == "MD5") && (param[3] == "S")) {
                    var md5 = hex_md5(param[4] + this.password);
                    this._SOCKET.sendData('USR ' + this.trial + ' MD5 S ' + md5 + '\r\n', 60000);
                }
                else if (param[2] == "OK") {
                    this.Nickname = unescape(param[4]);
                    document.getElementById('nickname').value = this.Nickname;
                    document.getElementById('SignInProgress').mode = "determined";
                    //this._SOCKET.sendData('CHG ' + this.trial + ' ' + this._STATUS + '\r\n', 60000);
                    this._SOCKET.sendData('SYN ' + this.trial + ' 0\r\n', 60000);
                }
                break;
            case "CHL":
                var md5 = hex_md5(param[2] + CHALLENGE);
                this._SOCKET.sendData('QRY ' + this.trial + ' msmsgs@msnmsgr.com ' + md5.length + '\r\n' + md5, 15000);
                break;
            case "QRY":
                break;
            case "QNG":
                
                break;
            case "MSG":
                if (this.data.length >= param[3]) {
                    var msgdata = this.data.substr(0, param[3]);
                    this.data = this.data.substr(param[3]);
                    _alert(msgdata);
                    var parts = msgdata.split('\r\n\r\n', 2);
                    msgdata = parts[1];
                    parts = parts[0].split('\r\n');
                    var Headers = new Array();
                    for (var i in parts) {
                        var header = parts[i].split(": ");
                        Headers[header[0]] = header[1];
                    }
                    parts = msgdata.split('\r\n');
                    var h = new Array();
                    for (var i in parts) {
                        var header = parts[i].split(": ");
                        h[header[0]] = header[1];
                    }
                    if (Headers['Content-Type'].substr(0, 20) == 'text/x-msmsgsprofile') {
                        this.profile = Headers;
                        if (Headers['EmailEnabled'] != 1) {
                            window.document.getElementById('emailItem').setAttribute('hidden', true);
                        }
                    }
                    else if (Headers['Content-Type'].substr(0, 37) == 'text/x-msmsgsinitialemailnotification') {
                        window.OnInitialEmailNotify(Headers, h);
                    }
                    else if (Headers['Content-Type'].substr(0, 30) == 'text/x-msmsgsemailnotification') {
                        window.OnEmailNotify(Headers, h);
                    }
                    else if (Headers['Content-Type'].substr(0, 35) == 'text/x-msmsgsactivemailnotification') {
                        window.OnActiveEmailChange(Headers, h);
                    }
                    else if (Headers['Content-Type'].substr(0, 35) == 'application/x-msmsgssystemmessage') {
                        window.OnSystemMessage(Headers, h);
                    }
                }
                else {
                    this.data = data + this.data;
                    return;
                }
                break;
            case "REA":
                if (param[3] == this.passport) {
                    document.getElementById('nickname').value = unescape(param[4]);
                    this.Nickname = unescape(param[4]);
                } else {
                    
                }
                break;
            case "CHG":
                this._STATUS = param[2];
                document.getElementById('status-description').value = this.bundle.GetStringFromName('YourStatusMsg' + param[2]);
                document.getElementById(param[2]+'_menuitem').setAttribute('checked', true);
                document.getElementById('status-image').src = StatusImages[param[2]];
                break;
            case "NLN":
                var con = this.Contacts['FL'][param[2]];
                if (con.Status == "FLN") {
                    var tc = document.getElementById(param[2]);
                    var ti = tc.parentNode.parentNode;
                    ti.parentNode.removeChild(ti);
                    
                    con.Status = param[1]
                    con.Nickname = unescape(param[3]);
                    ti = CreateContactNode(con, StatusImages[con.Status]);
                    
                    if (con.Status == "NLN" || con.Status == "FLN")
                        ti.firstChild.firstChild.setAttribute('label', ' ' + con.Nickname);
                    else
                        ti.firstChild.firstChild.setAttribute('label', ' ' + con.Nickname + ' (' + window.client.bundle.GetStringFromName('StatusMsg' + con.Status) + ')');
                    
                    if (client.Contacts['BL'][param[2]]) {
                        ti.firstChild.firstChild.setAttribute('src', StatusImages['BLK']);
                        ti.firstChild.firstChild.setAttribute('label', ' ' + con.Nickname + ' (' + window.client.bundle.GetStringFromName('StatusMsgBLK') + ')');
                    }
                    
                    document.getElementById('online-contacts-list').appendChild(ti);
                }
                else {
                    con.Status = param[1];
                    con.Nickname = unescape(param[3]);
                    var tc = document.getElementById(param[2]);
                    
                    if (client.Contacts['BL'][param[2]])
                        param[1] = 'BLK';
                    
                    tc.setAttribute('src', StatusImages[param[1]]);
                    tc.setAttribute('nickname', con.Nickname);
                    var str = " " + con.Nickname;
                    if (param[1] != "NLN") {
                        str += " (" + this.bundle.GetStringFromName('StatusMsg' + param[1]) + ")";
                    }
                    tc.setAttribute('label', str);
                    
                    var tree = document.getElementById('contact-list-tree');
                    var bx = tree.boxObject.QueryInterface(Components.interfaces.nsITreeBoxObject);
                    bx.invalidate();
                }
                break;
            case "FLN":
                var tc = document.getElementById(param[1]);
                var ti = tc.parentNode.parentNode;
                ti.parentNode.removeChild(ti);
                
                var con = this.Contacts['FL'][param[1]];
                con.Status = 'FLN';
                ti = CreateContactNode(con, StatusImages[con.Status]);
                
                if (client.Contacts['BL'][param[1]]) {
                    ti.firstChild.firstChild.setAttribute('src', StatusImages['BLK']);
                    ti.firstChild.firstChild.setAttribute('label', ' ' + con.Nickname + ' (' + window.client.bundle.GetStringFromName('StatusMsgBLK') + ')');
                }
                
                document.getElementById('offline-contacts-list').appendChild(ti);
                break;
            case "SYN":
                this.__syncing = true;
                break;
            case "PRP":
                switch (param[3]) {
                    case "PHH":
                        if (typeof(param[4]) != 'undefined')
                            this._HOME_PHONE = unescape(param[4]);
                        break;
                    case "PHW":
                        if (typeof(param[4]) != 'undefined')
                            this._WORK_PHONE = unescape(param[4]);
                        break;
                    case "PHM":
                        if (typeof(param[4]) != 'undefined')
                            this._MOBILE_PHONE = unescape(param[4]);
                        break;
                    case "MOB":
                        if (typeof(param[4]) != 'undefined')
                            this._MOBILE_ENABLED = param[4];
                        break;
                    case "MBE":
                        if (typeof(param[4]) != 'undefined')
                            this._MSN_MOBILE = param[4];
                        break;
                }
                break;
            case "GTC":
                this._ADD_APPROVE = param[3];
                break;
            case "BLP":
                this._CONTACT_APPROVE = param[3];
                break;
            case "ILN":
                var nln = "NLN " + param[2] + " " + param[3] + " " + param[4] + '\r\n';
                this.data = nln + this.data;
                break;
            case "LST":
                if (param[4] == param[5] && param[4] == 0 && this.__syncing) {
                    if (param[2] == 'RL') {
                        delete this.__syncing;
                        setupContacts();
                        this.status = this._STATUS;
                    }
                    break;
                }
                if (!this.Contacts[param[2]][param[6]])
                    this.Contacts[param[2]][param[6]] = new MSNContact(param[6], param[7]);
                if (param[2] == "FL") {
                    this.Contacts[param[2]][param[6]].Groups = param[8].split(',');
                }

                var pb = window.document.getElementById('SignInProgress');
                var prog = (param[4] / param[5]) * 100;
                pb.setAttribute('value', prog.toFixed(0) + "%");
                if (param[2] == "RL") {
                    if (typeof(this.Contacts['AL'][param[6]]) != 'object') {
                        if (typeof(this.Contacts['BL'][param[6]]) != 'object') {
                            window.openDialog('chrome://msnmsgr/content/contactaddprompt.xul', '_blank', 'chrome', param[6], param[7]);
                        }
                    }
                    if ((param[4] == param[5]) && this.__syncing) {
                        delete this.__syncing;
                        setupContacts();
                        this.status = this._STATUS;
                    }
                }
                break;
            case "BPR":
                var con = this.Contacts['FL'][param[2]];
                switch (param[3]) {
                    case "PHH":
                        if (typeof(param[4]) != 'undefined')
                            con._HOME_PHONE = unescape(param[4]);
                        break;
                    case "PHW":
                        if (typeof(param[4]) != 'undefined')
                            con._WORK_PHONE = unescape(param[4]);
                        break;
                    case "PHM":
                        if (typeof(param[4]) != 'undefined')
                            con._MOBILE_PHONE = unescape(param[4]);
                        break;
                    case "MOB":
                        if (typeof(param[4]) != 'undefined')
                            con._MOBILE_ENABLED = param[4];
                        break;
                }
                break;
            case "LSG":
                this.Groups[param[5]] = unescape(param[6]);
                break;
            case "RNG":
                var newSession = new MSNSession(this);
                var host = param[2].split(':');
                newSession.answer(host[0], host[1], param[4], param[1]);
                //find previous session window if available
                var w = findIncomingSessionWindowFor(param[5]);
                if (w) {
                    this.unregisterSession(w._SESSION);
                    newSession._WINDOW = w;
                    w._SESSION = newSession;
                }
                break;
            case "OUT":
                doSignOut();
                switch (param[1]) {
                    case "OTH":
                        alert(this.bundle.GetStringFromName('OUT_OTH'));
                        break;
                }
                break;
            case "ADD":
                if (param[1] == 0) {
                    var win = window.openDialog('chrome://msnmsgr/content/contactaddprompt.xul', '_blank', 'chrome', param[4], param[5]);
                } else {
                    if (typeof(this.Contacts[param[2]][param[4]]) == "undefined") {
                        this.Contacts[param[2]][param[4]] = new MSNContact(param[4], param[5]);
                        alert('made new MSNContact');
                    }
                    if (param[2] == "FL") {
                        this.Contacts[param[2]][param[4]].Group = param[6];
                    }
                    var con = this.Contacts[param[2]][param[4]]
                    //con.Status = "FLN";
                    if (param[2] == "FL") {
                        var ti = CreateContactNode(con, StatusImages[con.Status]);
                        if (con.Status == "FLN") {
                            document.getElementById('offline-contacts-list').appendChild(ti);
                        } else {
                            if (con.Status != "NLN") {
                                ti.firstChild.firstChild.setAttribute('label', ' ' + con.Nickname + ' (' + this.bundle.GetStringFromName('StatusMsg' + con.Status) + ')');
                            }
                            document.getElementById('online-contacts-list').appendChild(ti);
                        }
                    } else {
                        ti = document.getElementById(param[4]);
                        if (ti) {
                            con = this.Contacts['FL'][param[4]];
                            if (this.Contacts['BL'][param[4]]) {
                                ti.setAttribute('src', StatusImages['BLK']);
                                ti.setAttribute('label', ' ' + con.Nickname + ' (' + window.client.bundle.GetStringFromName('StatusMsgBLK') + ')');
                            } else {
                                ti.setAttribute('src', StatusImages[con.Status]);
                                if (con.Status == "FLN" || con.Status == "NLN")
                                    ti.setAttribute('label', ' ' + con.Nickname);
                                else
                                    ti.setAttribute('label', ' ' + con.Nickname + ' (' + this.bundle.GetStringFromName('StatusMsg' + con.Status) + ')');
                            }
                        }
                    }
                }
                break;
            case "REM":
                if (param[1] == 0) {
                    
                } else {
                    if (param[2] == 'FL') {
                        if (!param[5])
                            param[5] = 0;
                        var item = document.getElementById(param[4]).parentNode.parentNode;
                        item.parentNode.removeChild(item);
                        delete this.Contacts[param[2]][param[4]];
                    } else {
                        delete this.Contacts[param[2]][param[4]];
                    }
                }
                break;
            case "URL":
                gotoURL(param[3], param[2], param[4]);
                break;
            case "215":
                break;
            case "911":
                this.onClose();
                alert(this.bundle.GetStringFromName('Err_911'));
                
                break;
            default:
                alert(data);
                break;
        }
    }
}

MSNObject.prototype.trial getter = function() {
    this._TRIAL++;
    return this._TRIAL;
}

function setupContacts () {
    var stat = document.getElementById('initial-status').value;
    /* Clear contacts */
    var list = document.getElementById('online-contacts-list');
    while (list.childNodes.length > 0) {
        list.removeChild(list.childNodes.item(0));
    }
    var list = document.getElementById('offline-contacts-list');
    while (list.childNodes.length > 0) {
        list.removeChild(list.childNodes.item(0));
    }
    /* Add contacts */
    for (var c in client.Contacts['FL']) {
        var con = client.Contacts['FL'][c];
        var ti = CreateContactNode(con, StatusImages[con.Status]);
        var list = (con.Status == "FLN") ? 'offline-contacts-list' : 'online-contacts-list';
        
        if (client.Contacts['BL'][c]) {
            ti.firstChild.firstChild.setAttribute('src', StatusImages['BLK']);
            ti.firstChild.firstChild.setAttribute('label', ' ' + con.Nickname + ' (' + window.client.bundle.GetStringFromName('StatusMsgBLK') + ')');
        }
        
        if (con.Status == "FLN") {
            
        } else {
            if (con.Status != "NLN") {
                ti.firstChild.firstChild.setAttribute('label', ' ' + con.Nickname + ' (' + window.client.bundle.GetStringFromName('StatusMsg' + con.Status) + ')');
            }
        }
        document.getElementById(list).appendChild(ti);
    }
    document.getElementById('main-pages').selectedIndex = 2;
}

function setupContacts2 () {
    clearContacts();
    document.getElementById('contact-list-tree').childNodes[1]
}

function clearContacts () {
    
}

function __ping() {
    client._SOCKET.sendData('PNG\r\n', 60000);
}

function MSNContact(email, nick, stat) {
    //alert('New Contact:  ' + email + "   " + stat);
    this.EMail = email;
    this.Nickname = unescape(nick);
    this.Status = stat ? stat : 'FLN';
}